"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteFunctionBuilderlessProduction = exports.updateFunctionBuilderlessProduction = exports.getFunctionBuilderlessProduction = exports.createFunctionBuilderlessProduction = void 0;
const rest_modules_1 = require("@wix/sdk-runtime/rest-modules");
const timestamp_1 = require("@wix/sdk-runtime/transformations/timestamp");
const timestamp_2 = require("@wix/sdk-runtime/transformations/timestamp");
const field_mask_1 = require("@wix/sdk-runtime/transformations/field-mask");
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
const rest_modules_2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl(opts) {
    const domainToMappings = {
        'manage._base_domain_': [
            {
                srcPath: '/_api/functions/v1/function-builderless-productions',
                destPath: '/v1/function-builderless-productions',
            },
        ],
    };
    return (0, rest_modules_2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
const PACKAGE_NAME = '@wix/auto_sdk_functions_function-builderless-productions';
/** Creates FunctionBuilderlessProduction */
function createFunctionBuilderlessProduction(payload) {
    function __createFunctionBuilderlessProduction({ host }) {
        const serializedData = (0, transform_paths_1.transformPaths)(payload, [
            {
                transformFn: timestamp_1.transformSDKTimestampToRESTTimestamp,
                paths: [
                    { path: 'functionBuilderlessProduction.createdDate' },
                    { path: 'functionBuilderlessProduction.updatedDate' },
                ],
            },
        ]);
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'POST',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.CreateFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions',
                data: serializedData,
                host,
            }),
            data: serializedData,
            transformResponse: (payload) => (0, transform_paths_1.transformPaths)(payload, [
                {
                    transformFn: timestamp_2.transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __createFunctionBuilderlessProduction;
}
exports.createFunctionBuilderlessProduction = createFunctionBuilderlessProduction;
/** Gets FunctionBuilderlessProduction */
function getFunctionBuilderlessProduction(payload) {
    function __getFunctionBuilderlessProduction({ host }) {
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'GET',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.GetFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionId}',
                data: payload,
                host,
            }),
            params: (0, rest_modules_1.toURLSearchParams)(payload),
            transformResponse: (payload) => (0, transform_paths_1.transformPaths)(payload, [
                {
                    transformFn: timestamp_2.transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __getFunctionBuilderlessProduction;
}
exports.getFunctionBuilderlessProduction = getFunctionBuilderlessProduction;
/** Updates FunctionBuilderlessProduction */
function updateFunctionBuilderlessProduction(payload) {
    function __updateFunctionBuilderlessProduction({ host }) {
        const serializedData = (0, transform_paths_1.transformPaths)(payload, [
            {
                transformFn: field_mask_1.transformSDKFieldMaskToRESTFieldMask,
                paths: [{ path: 'fieldMask' }],
            },
            {
                transformFn: timestamp_1.transformSDKTimestampToRESTTimestamp,
                paths: [
                    { path: 'functionBuilderlessProduction.createdDate' },
                    { path: 'functionBuilderlessProduction.updatedDate' },
                ],
            },
        ]);
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'PATCH',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.UpdateFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionBuilderlessProduction.id}',
                data: serializedData,
                host,
            }),
            data: serializedData,
            transformResponse: (payload) => (0, transform_paths_1.transformPaths)(payload, [
                {
                    transformFn: timestamp_2.transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __updateFunctionBuilderlessProduction;
}
exports.updateFunctionBuilderlessProduction = updateFunctionBuilderlessProduction;
/** Deletes FunctionBuilderlessProduction */
function deleteFunctionBuilderlessProduction(payload) {
    function __deleteFunctionBuilderlessProduction({ host }) {
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'DELETE',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.DeleteFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionId}',
                data: payload,
                host,
            }),
            params: (0, rest_modules_1.toURLSearchParams)(payload),
        };
        return metadata;
    }
    return __deleteFunctionBuilderlessProduction;
}
exports.deleteFunctionBuilderlessProduction = deleteFunctionBuilderlessProduction;
//# sourceMappingURL=functions-v1-builderless-production-function-builderless-productions.http.js.map