"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteFunctionBuilderlessProduction = exports.updateFunctionBuilderlessProduction = exports.getFunctionBuilderlessProduction = exports.createFunctionBuilderlessProduction = exports.WebhookIdentityType = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixFunctionsV1BuilderlessProduction = __importStar(require("./functions-v1-builderless-production-function-builderless-productions.http.js"));
var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (exports.WebhookIdentityType = WebhookIdentityType = {}));
/**
 * Creates FunctionBuilderlessProduction
 * @internal
 * @documentationMaturity preview
 * @requiredField options.functionBuilderlessProduction.formTemplateExtensionId
 * @requiredField options.functionBuilderlessProduction.formValue
 * @requiredField options.functionBuilderlessProduction.functionTemplateExtensionId
 * @permissionId FUNCTIONS.FUNCTION_BUILDERLESS_PRODUCTION_CREATE
 * @returns Created Function builderless production
 * @fqn wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.CreateFunctionBuilderlessProduction
 */
async function createFunctionBuilderlessProduction(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        functionBuilderlessProduction: options?.functionBuilderlessProduction,
    });
    const reqOpts = ambassadorWixFunctionsV1BuilderlessProduction.createFunctionBuilderlessProduction(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)
            ?.functionBuilderlessProduction;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                functionBuilderlessProduction: '$[0].functionBuilderlessProduction',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.createFunctionBuilderlessProduction = createFunctionBuilderlessProduction;
/**
 * Gets FunctionBuilderlessProduction
 * @param functionId - Id of the function of the requested builderless production
 * @internal
 * @documentationMaturity preview
 * @requiredField functionId
 * @permissionId FUNCTIONS.FUNCTION_BUILDERLESS_PRODUCTION_READ
 * @returns The requested Function builderless production
 * @fqn wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.GetFunctionBuilderlessProduction
 */
async function getFunctionBuilderlessProduction(functionId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        functionId: functionId,
    });
    const reqOpts = ambassadorWixFunctionsV1BuilderlessProduction.getFunctionBuilderlessProduction(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)
            ?.functionBuilderlessProduction;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { functionId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['functionId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.getFunctionBuilderlessProduction = getFunctionBuilderlessProduction;
/**
 * Updates FunctionBuilderlessProduction
 * @param _id - Id, which is a function id
 * @internal
 * @documentationMaturity preview
 * @requiredField _id
 * @requiredField options.functionBuilderlessProduction.formTemplateExtensionId
 * @requiredField options.functionBuilderlessProduction.formValue
 * @permissionId FUNCTIONS.FUNCTION_BUILDERLESS_PRODUCTION_UPDATE
 * @returns Updated Function builderless production
 * @fqn wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.UpdateFunctionBuilderlessProduction
 */
async function updateFunctionBuilderlessProduction(_id, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        functionBuilderlessProduction: {
            ...options?.functionBuilderlessProduction,
            id: _id,
        },
    });
    const reqOpts = ambassadorWixFunctionsV1BuilderlessProduction.updateFunctionBuilderlessProduction(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)
            ?.functionBuilderlessProduction;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {
                functionBuilderlessProduction: '$[1].functionBuilderlessProduction',
            },
            explicitPathsToArguments: {
                'functionBuilderlessProduction.id': '$[0]',
            },
            singleArgumentUnchanged: false,
        }, ['_id', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.updateFunctionBuilderlessProduction = updateFunctionBuilderlessProduction;
/**
 * Deletes FunctionBuilderlessProduction
 * @param functionId - Id of the builderless production id, which is a function id
 * @internal
 * @documentationMaturity preview
 * @requiredField functionId
 * @permissionId FUNCTIONS.FUNCTION_BUILDERLESS_PRODUCTION_DELETE
 * @fqn wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.DeleteFunctionBuilderlessProduction
 */
async function deleteFunctionBuilderlessProduction(functionId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        functionId: functionId,
    });
    const reqOpts = ambassadorWixFunctionsV1BuilderlessProduction.deleteFunctionBuilderlessProduction(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { functionId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['functionId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.deleteFunctionBuilderlessProduction = deleteFunctionBuilderlessProduction;
//# sourceMappingURL=functions-v1-builderless-production-function-builderless-productions.universal.js.map