import { toURLSearchParams } from '@wix/sdk-runtime/rest-modules';
import { transformSDKTimestampToRESTTimestamp } from '@wix/sdk-runtime/transformations/timestamp';
import { transformRESTTimestampToSDKTimestamp } from '@wix/sdk-runtime/transformations/timestamp';
import { transformSDKFieldMaskToRESTFieldMask } from '@wix/sdk-runtime/transformations/field-mask';
import { transformPaths } from '@wix/sdk-runtime/transformations/transform-paths';
import { resolveUrl } from '@wix/sdk-runtime/rest-modules';
function resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl(opts) {
    const domainToMappings = {
        'manage._base_domain_': [
            {
                srcPath: '/_api/functions/v1/function-builderless-productions',
                destPath: '/v1/function-builderless-productions',
            },
        ],
    };
    return resolveUrl(Object.assign(opts, { domainToMappings }));
}
const PACKAGE_NAME = '@wix/auto_sdk_functions_function-builderless-productions';
/** Creates FunctionBuilderlessProduction */
export function createFunctionBuilderlessProduction(payload) {
    function __createFunctionBuilderlessProduction({ host }) {
        const serializedData = transformPaths(payload, [
            {
                transformFn: transformSDKTimestampToRESTTimestamp,
                paths: [
                    { path: 'functionBuilderlessProduction.createdDate' },
                    { path: 'functionBuilderlessProduction.updatedDate' },
                ],
            },
        ]);
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'POST',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.CreateFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions',
                data: serializedData,
                host,
            }),
            data: serializedData,
            transformResponse: (payload) => transformPaths(payload, [
                {
                    transformFn: transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __createFunctionBuilderlessProduction;
}
/** Gets FunctionBuilderlessProduction */
export function getFunctionBuilderlessProduction(payload) {
    function __getFunctionBuilderlessProduction({ host }) {
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'GET',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.GetFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionId}',
                data: payload,
                host,
            }),
            params: toURLSearchParams(payload),
            transformResponse: (payload) => transformPaths(payload, [
                {
                    transformFn: transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __getFunctionBuilderlessProduction;
}
/** Updates FunctionBuilderlessProduction */
export function updateFunctionBuilderlessProduction(payload) {
    function __updateFunctionBuilderlessProduction({ host }) {
        const serializedData = transformPaths(payload, [
            {
                transformFn: transformSDKFieldMaskToRESTFieldMask,
                paths: [{ path: 'fieldMask' }],
            },
            {
                transformFn: transformSDKTimestampToRESTTimestamp,
                paths: [
                    { path: 'functionBuilderlessProduction.createdDate' },
                    { path: 'functionBuilderlessProduction.updatedDate' },
                ],
            },
        ]);
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'PATCH',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.UpdateFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionBuilderlessProduction.id}',
                data: serializedData,
                host,
            }),
            data: serializedData,
            transformResponse: (payload) => transformPaths(payload, [
                {
                    transformFn: transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'functionBuilderlessProduction.createdDate' },
                        { path: 'functionBuilderlessProduction.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __updateFunctionBuilderlessProduction;
}
/** Deletes FunctionBuilderlessProduction */
export function deleteFunctionBuilderlessProduction(payload) {
    function __deleteFunctionBuilderlessProduction({ host }) {
        const metadata = {
            entityFqdn: 'wix.functions.v1.builderless_production',
            method: 'DELETE',
            methodFqn: 'wix.functions.builderlessproductions.v1.FunctionBuilderlessProductions.DeleteFunctionBuilderlessProduction',
            packageName: PACKAGE_NAME,
            url: resolveWixFunctionsBuilderlessproductionsV1FunctionBuilderlessProductionsUrl({
                protoPath: '/v1/function-builderless-productions/{functionId}',
                data: payload,
                host,
            }),
            params: toURLSearchParams(payload),
        };
        return metadata;
    }
    return __deleteFunctionBuilderlessProduction;
}
//# sourceMappingURL=functions-v1-builderless-production-function-builderless-productions.http.js.map