import { HttpClient } from '@wix/sdk-types';
import { CreateFunctionBuilderlessProductionOptions, FunctionBuilderlessProduction, FunctionBuilderlessProductionNonNullableFields, UpdateFunctionBuilderlessProductionOptions } from './functions-v1-builderless-production-function-builderless-productions.universal.js';
export declare const __metadata: {
    PACKAGE_NAME: string;
};
/** @internal */
export declare function createFunctionBuilderlessProduction(httpClient: HttpClient): CreateFunctionBuilderlessProductionSignature;
interface CreateFunctionBuilderlessProductionSignature {
    /**
     * Creates FunctionBuilderlessProduction
     * @returns Created Function builderless production
     */
    (options?: CreateFunctionBuilderlessProductionOptions | undefined): Promise<FunctionBuilderlessProduction & FunctionBuilderlessProductionNonNullableFields>;
}
/** @internal */
export declare function getFunctionBuilderlessProduction(httpClient: HttpClient): GetFunctionBuilderlessProductionSignature;
interface GetFunctionBuilderlessProductionSignature {
    /**
     * Gets FunctionBuilderlessProduction
     * @param - Id of the function of the requested builderless production
     * @returns The requested Function builderless production
     */
    (functionId: string): Promise<FunctionBuilderlessProduction & FunctionBuilderlessProductionNonNullableFields>;
}
/** @internal */
export declare function updateFunctionBuilderlessProduction(httpClient: HttpClient): UpdateFunctionBuilderlessProductionSignature;
interface UpdateFunctionBuilderlessProductionSignature {
    /**
     * Updates FunctionBuilderlessProduction
     * @param - Id, which is a function id
     * @returns Updated Function builderless production
     */
    (_id: string | null, options?: UpdateFunctionBuilderlessProductionOptions | undefined): Promise<FunctionBuilderlessProduction & FunctionBuilderlessProductionNonNullableFields>;
}
/** @internal */
export declare function deleteFunctionBuilderlessProduction(httpClient: HttpClient): DeleteFunctionBuilderlessProductionSignature;
interface DeleteFunctionBuilderlessProductionSignature {
    /**
     * Deletes FunctionBuilderlessProduction
     * @param - Id of the builderless production id, which is a function id
     */
    (functionId: string): Promise<void>;
}
export { ActionEvent, CreateFunctionBuilderlessProductionOptions, CreateFunctionBuilderlessProductionRequest, CreateFunctionBuilderlessProductionResponse, CreateFunctionBuilderlessProductionResponseNonNullableFields, DeleteFunctionBuilderlessProductionRequest, DeleteFunctionBuilderlessProductionResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, EntityDeletedEvent, EntityUpdatedEvent, FunctionBuilderlessProduction, FunctionBuilderlessProductionNonNullableFields, GetFunctionBuilderlessProductionRequest, GetFunctionBuilderlessProductionResponse, GetFunctionBuilderlessProductionResponseNonNullableFields, IdentificationData, IdentificationDataIdOneOf, MessageEnvelope, RestoreInfo, UpdateFunctionBuilderlessProductionOptions, UpdateFunctionBuilderlessProductionRequest, UpdateFunctionBuilderlessProductionResponse, UpdateFunctionBuilderlessProductionResponseNonNullableFields, WebhookIdentityType, } from './functions-v1-builderless-production-function-builderless-productions.universal.js';
